// Copyright 2000-2005 the Contributors, as shown in the revision logs.
// Licensed under the Apache Public Source License 2.0 ("the License").
// You may not use this file except in compliance with the License.

package org.ibex.util;

/** Simple implementation of a blocking, counting semaphore. */
public class Semaphore {
    
    private int val = 0;

    public synchronized void dec() {
        val--;
    }
    
    /** Decrement the counter, blocking if zero. */
    public synchronized void block() {
        while(val <= 0) {
            try {
                wait();
            } catch (InterruptedException e) {
            } catch (Throwable e) {
                if (Log.on) Log.info(this, "Exception in Semaphore.block(); this should never happen");
                if (Log.on) Log.info(this, e);
            }
        }
        val--;
    }
    
    /** Incremenet the counter. */
    public synchronized void release() {
        val++;
        notify();
    }

}
